"use strict";

const fs = require("fs");
const path = require("path");
const lodash = require("lodash");
const userhome = require("userhome");
const constx = require("./constx");
function HomeConfig(a) {
  a = a || {};
  const b = a.environmentVar || "NODE_DEVEBOT_CLI";
  const c = process.env[b];
  const d = a.configSubdir || "." + constx.FRAMEWORK.NAMESPACE;
  const e = a.configFilename || "config";
  const f = lodash.merge({
    protocol: "http",
    host: "0.0.0.0",
    port: 17779,
    path: "/-",
    authen: {
      token_key: "master",
      token_secret: "s3cr3tpa$$w0rd"
    },
    tunnel: {
      enabled: false,
      rejectUnauthorized: false
    }
  }, a.defaultConfig);
  const g = this;
  const h = userhome(d);
  try {
    fs.readdirSync(h);
  } catch (a) {
    if (a.code == "ENOENT") {
      fs.mkdirSync(h);
    }
  }
  const i = function (b, c, d) {
    let f = b;
    const g = [e];
    if (lodash.isString(d) && d.length > 0) {
      g.push(".", d);
    }
    g.push(".json");
    const h = path.join(c, g.join(""));
    try {
      f = JSON.parse(fs.readFileSync(h, "utf8"));
    } catch (b) {
      if (b.code == "ENOENT") {
        if (a.configFileInitialized) {
          fs.writeFileSync(h, JSON.stringify(f, null, 2), "utf8");
        }
      }
    }
    return f;
  };
  let j = i(f, h);
  g.getContext = function () {
    return c;
  };
  g.getConfig = function () {
    if (lodash.isString(c) && !lodash.isEmpty(c)) {
      g.loadConfig(c);
    }
    return lodash.clone(j, true);
  };
  g.loadConfig = function (a) {
    if (!lodash.isString(a)) return;
    j = lodash.defaultsDeep(i({}, h, a), j);
  };
  g.saveConfig = function (a, b) {
    if (!lodash.isString(a) || a.length == 0) return;
    const c = path.join(h, "config." + a + ".json");
    if (!lodash.isObject(b)) return;
    j = lodash.defaultsDeep(b, j);
    fs.writeFileSync(c, JSON.stringify(j, null, 2), "utf8");
  };
}
module.exports = HomeConfig;