"use strict";

const lodash = require("lodash");
const util = require("util");
const Table = require("cli-table");
const Validator = require("jsonschema").Validator;
const validator = new Validator();
const clientInfo = require("./appinfo.js");
const constx = require("./constx.js");
function TextUI(a) {
  a = a || {};
  const b = {
    style: {
      head: [] //disable colors in header cells
      ,
      border: [] //disable colors for the border
    }
  };

  this.displayCliHeader = function (a) {
    a = a || {};
    const b = a.appinfo;
    console.info("Client[%s]: %s (v%s)", clientInfo.name, clientInfo.description, clientInfo.version);
    if (lodash.isObject(b) && b.name != clientInfo.name) {
      console.info("Server[%s]: %s (v%s)", b.name, b.description, b.version);
    }
  };
  this.displayCliFooter = function (b) {
    const c = a.config;
    const d = a.myperf;
    const e = [];
    if (lodash.isObject(c)) {
      const a = c.getContext();
      e.push("│", lodash.isEmpty(a) ? "default" : a);
      const b = c.getConfig();
      if (lodash.isObject(b)) {
        e.push(util.format(" - %s://%s:%s%s", b.protocol || "http", b.host, b.port, b.path));
      }
    }
    if (lodash.isObject(d)) {
      const a = d.stop();
      e.push("\n");
      e.push("│", util.format("Time: %s - Memory: %s", a.time_text, a.memory_text));
    }
    ["", "┌", e.join(""), "└"].forEach(function (a) {
      console.info(a);
    });
  };
  this.displayCliOutput = function (a) {
    a = a || {};
    const b = validator.validate(a, constx.argumentSchema);
    if (b.errors.length > 0) {
      console.info(JSON.stringify(b.errors, null, 2));
      c(a);
    } else {
      const b = {};
      b.isError = a.state == "failed";
      let c = a.payload || [];
      if (!lodash.isArray(c)) c = [c];
      c.forEach(function (a) {
        d(a, b);
      });
    }
  };
  const c = function (a) {
    const c = new Table(lodash.assign(b, {
      head: ["Invalid output format. Render full result object in JSON format"],
      colWidths: [78]
    }));
    c.push([JSON.stringify(a, null, 2)]);
    console.info("");
    console.info(c.toString());
  };
  const d = function (a, b) {
    i(a, b);
    switch (a.type) {
      case "record":
      case "object":
        e(a);
        break;
      case "table":
      case "grid":
        f(a);
        break;
      case "json":
        g(a);
        break;
      default:
        h(a);
        break;
    }
  };
  const e = function (a) {
    const c = a.label;
    const d = a.data;
    const e = Object.keys(d);
    const f = [];
    e.forEach(function (a) {
      if (c[a]) {
        const b = {};
        b[c[a]] = d[a];
        f.push(b);
      }
    });
    const g = new Table(lodash.assign(b, {}));
    f.forEach(function (a) {
      g.push(a);
    });
    console.info(g.toString());
  };
  const f = function (a) {
    const c = a.label;
    const d = Object.keys(c);
    const e = [];
    d.forEach(function (a) {
      e.push(c[a]);
    });
    const f = a.data;
    const g = [];
    f.forEach(function (a) {
      const b = [];
      for (let c = 0; c < d.length; c++) {
        b.push(a[d[c]]);
      }
      g.push(b);
    });
    const h = new Table(lodash.assign(b, {
      head: e
    }));
    g.forEach(function (a) {
      h.push(a);
    });
    console.info(h.toString());
  };
  const g = function (a) {
    const c = new Table(lodash.assign(b, {
      head: ["JSON"],
      colWidths: [78]
    }));
    c.push([JSON.stringify(a.data, null, 2)]);
    console.info(c.toString());
  };
  const h = function (a) {
    const c = new Table(lodash.assign(b, {
      head: ["Unknown result type"],
      colWidths: [78]
    }));
    c.push([JSON.stringify(a.data, null, 2)]);
    console.info(c.toString());
  };
  const i = function (a, b) {
    if (lodash.isString(a.title)) {
      console.info("");
      const c = b && b.isError ? "[x]" : "[v]";
      console.info("%s %s", c, a.title);
    }
  };
  this.displayException = function (a) {
    ["", "Command has been broken - " + a, "------------------------------------------------------------------------------------", "For more information about using this application, please see the guide:", "" + clientInfo.homepage, ""].forEach(function (a) {
      console.info(a);
    });
  };
}
module.exports = TextUI;